#include <mask.h>
#include <form.h>
#include <printapp.h>
#include <utility.h>

#include "lf.h"
#include "soggetti.h"
#include "sezioni.h"

#include "at2.h"
#include "at2600a.h"

#define ALIAS_LCP	100
//#define ALIAS_TCS	200

#define ISCRITTI 'I'
enum ts { undefined = 0, elenco = 1, etichette = 2 };

// definizione form per etichette
class TEti_iscritti_form : public TForm
{
public:
	
	virtual TCursor* cursor() const;
	virtual TRelation* relation() const;
	TPrint_section& get_body() { return section('B'); } ;
  TEti_iscritti_form(): TForm() {};
  TEti_iscritti_form(const char* form, const char * code = "", int editlevel = 0, const char* desc = "")
    						: TForm(form,code,editlevel,desc) {};
  virtual ~TEti_iscritti_form() {};
};

class TIscritti_application : public TPrintapp
{
  TRelation*					_rel;
  TMask*      				_msk;
  TEti_iscritti_form*	_form_eti;
  
  int 								_cur1, _cur2, _cur3, _cur4;
  TParagraph_string 	_cognome_nome;
  TDate 							_data_stampa;
	ts 	      					_tipo_stampa;
	TString							_codsez, _codsot;
	char								_tipo_iscdim;	// iscritti o dimessi
	TDate								_dataini, _datafin;

  static bool filter_func_iscritti(const TRelation *);
  
protected:
  virtual bool user_create();
  virtual bool user_destroy();
  virtual bool set_print(int m);
  virtual void set_page(int file, int cnt);
  virtual bool preprocess_page(int file, int counter);

public:
  void crea_intestazione();
  void filtra_sezioni();
  void header_sezione(TString codsez, TString codsot);
  TMask& app_mask() { return *_msk; }
  TIscritti_application() : _data_stampa(TODAY), _cognome_nome("",25) {}
};

HIDDEN inline TIscritti_application& app() { return (TIscritti_application&) main_app(); }

TCursor* TEti_iscritti_form::cursor() const { return app().current_cursor(); }

TRelation* TEti_iscritti_form::relation() const { return cursor()->relation(); }

void TIscritti_application::filtra_sezioni()
{
 	TString sezini = _msk->get(F_SEZINI);
 	TString sotini = _msk->get(F_SOTINI);
 	TString sezfin = _msk->get(F_SEZFIN);
 	TString sotfin = _msk->get(F_SOTFIN);
  select_cursor(_cur4); 
  TLocalisamfile& fl = current_cursor()->file(LF_SOGGETTI);
  TRectype da(fl.curr());
  TRectype a(fl.curr());   
  da.zero();
  a.zero();
  if ((sezini.not_empty()) && (sezini.ok()))
		da.put(SOG_CODSEZ, sezini);
  if ((sotini.not_empty()) && (sotini.ok()))    	
		da.put(SOG_CODSOT, sotini);
  if ((sezfin.not_empty()) && (sezfin.ok()))
		a.put(SOG_CODSEZ, sezfin);
  if ((sotfin.not_empty()) && (sotfin.ok()))    	
		a.put(SOG_CODSOT, sotfin);
	current_cursor()->setregion(da, a);
}	

void TIscritti_application::set_page(int file, int cnt)
{
	// costruzione etichette
	switch (_tipo_stampa)
	{
		case etichette:
		{
			TPrint_section& corpo = _form_eti->get_body();
			corpo.reset();
			corpo.update();
  		for (int i = 0; i < corpo.height(); i++)
  		{
  			TPrintrow& riga = corpo.row(i);
  			set_row(i+1,riga);
			}  			
			force_setpage(TRUE);	// serve perchè alla prossima etichetta rifaccia la setpage
														// altrimenti stampa sempre la stessa etichetta
		}
		break;
		case elenco:
		{
			set_row(1,"@0g@pn", FLD(LF_SOGGETTI,SOG_CODICE,"######"));
			set_row(1,"@7g@S", FLD(LF_SOGGETTI,SOG_CATDON));
			set_row(1,"@10g#a", &_cognome_nome);
			set_row(1,"@36g@ld", FLD(LF_SOGGETTI,SOG_DATANASC));
			set_row(1,"@47g@ld", FLD(LF_SOGGETTI,SOG_DATAISC));
			set_row(1,"@58g@ld", FLD(LF_SOGGETTI,SOG_DATADIM));
		}
		break;
	}					
}

bool TIscritti_application::filter_func_iscritti(const TRelation * rel)
{   

	bool filtrato = TRUE;
	
	TLocalisamfile*      sog = &(rel->lfile(LF_SOGGETTI)); 

	TAssoc_array categorie;

	TMask& msk = app().app_mask();

  TString catpri = msk.get(F_CAT1);
  TString catsec = msk.get(F_CAT2);
  TString catter = msk.get(F_CAT3);
  TString catqua = msk.get(F_CAT4);
  TString catqui = msk.get(F_CAT5);
  TString catses = msk.get(F_CAT6);

  if (catpri.not_empty() && catpri.ok())
  	categorie.add((const char*) catpri);
  if (catsec.not_empty() && catsec.ok())
  	categorie.add((const char*) catsec);
  if (catter.not_empty() && catter.ok())
  	categorie.add((const char*) catter);
  if (catqua.not_empty() && catqua.ok())
  	categorie.add((const char*) catqua);
  if (catqui.not_empty() && catqui.ok())
  	categorie.add((const char*) catqui);
  if (catses.not_empty() && catses.ok())
  	categorie.add((const char*) catses);
	
	if (categorie.items() != 0)
	{
		TString cat = sog->curr().get(SOG_CATDON);
		if (categorie.is_key((const char*) cat))
			filtrato = TRUE;
		else
			filtrato = FALSE;	
	}	
	if (filtrato)
	{
  	TRectype from (sog->curr());
  	TRectype to (sog->curr());
  	from.zero();
  	to.zero();
		if (app()._tipo_iscdim == ISCRITTI)
		{
   		from.put(SOG_DATAISC, app()._dataini);
  		to.put(SOG_DATAISC, app()._datafin);
  		if ((sog->curr() >= from) && (sog->curr() <= to))
    		filtrato = TRUE;
    	else
    		filtrato = FALSE;	
		}
		else
		{
   		from.put(SOG_DATADIM, app()._dataini);
  		to.put(SOG_DATADIM, app()._datafin);
  		if ((sog->curr() >= from) && (sog->curr() <= to))
    		filtrato = TRUE;
    	else
    		filtrato = FALSE;	
		}				
	}
  return filtrato;
}

bool TIscritti_application::preprocess_page(int file, int counter)
{
	// contatore soggetti stampati 
	// per ora non c'è
	if (_tipo_stampa == elenco)
	{
		TString nome = current_cursor()->curr().get(SOG_COGNOME);
		nome << " ";
		nome << current_cursor()->curr().get(SOG_NOME);
		_cognome_nome = nome;
		
		// salto pagina se cambio sezione
		TString codsez = current_cursor()->curr().get(SOG_CODSEZ);		
		TString codsot = current_cursor()->curr().get(SOG_CODSOT);		
		if ((_codsez!=codsez)||(_codsot!=codsot))
		{
			//if (!_codsez.blank())
			if (_codsez != "**")
				printer().formfeed();
			_codsez = codsez;
			_codsot = codsot;
			header_sezione(codsez, codsot);
		}
	}		
  return TRUE;
}

void TIscritti_application::header_sezione(TString codsez, TString codsot)
{
	TString densez = current_cursor()->curr(LF_SEZIONI).get(SEZ_DENSEZ);
	TString densot = current_cursor()->curr(LF_SEZIONI).get(SEZ_DENSOT);
	TString intestazione(132);
	intestazione = "Sezione: ";
	intestazione << codsez;
	intestazione << "/";
	intestazione << codsot;
	intestazione << " ";
	intestazione << densez;
	if ((densot.ok())&& (densot.not_empty()))
	{
		intestazione << "/";
		intestazione << densot;
	}		
	intestazione.center_just();
	set_header(1,"@0g%s", (const char*) intestazione);
	return;
}

bool TIscritti_application::set_print(int m)
{ 
	_tipo_stampa = undefined;
  KEY tasto;
  tasto = _msk->run();
  switch (tasto)
  {
  case F_ELENCO:
  	_tipo_stampa = elenco;
  	//_codsez.spaces(2);
  	//_codsot.spaces(2);
  	_codsez = "**";
  	_codsot = "**";
  	break;
  case F_ETICHETTE:
  	_tipo_stampa = etichette;	
  	break;
  }	
	if (_tipo_stampa != undefined)
  {
    reset_files(); 
    add_file(LF_SOGGETTI);

		_tipo_iscdim = _msk->get(F_TIPO)[0];
		_dataini = _msk->get(F_DATAINI);    
		_datafin = _msk->get(F_DATAFIN);    
    // filtro per sezioni selezionati
	  filtra_sezioni();
                                     
		// filtro per categorie
		current_cursor()->set_filterfunction(filter_func_iscritti);
		reset_print();
		crea_intestazione();
    return TRUE;
  }
  else
    return FALSE;
}

void TIscritti_application::crea_intestazione()
{
  reset_header();
  
  if (_tipo_stampa == elenco)
  {
  	TString sep(132);
  	sep = "ELENCO ";
  	if (_tipo_iscdim == ISCRITTI)
  		sep << "ISCRITTI";
		else  		
  		sep << "DIMESSI";
  	if (_dataini.ok())
  	{
  		sep << " dal ";
  		sep << _dataini.string();
		}
  	if (_datafin.ok())
  	{
  		sep << " al ";
  		sep << _datafin.string();
		}
		sep.center_just();
  	set_header(2, "@0g%s", (const char*) sep);
  	TString data_stampa = _data_stampa.string();
  	set_header(2,"@0g%10s", (const char*) data_stampa);
  	sep = "";
  	sep << "Pag. @#";
  	set_header(2, "@120g%s", (const char*) sep);  
  	
  	sep = "";
  	sep.fill('-');
  	set_header(3, (const char *) sep);

  	set_header(4,"@0gCod.@7gC.@10gCognome e nome@36gNato il@47gData isc.@58gData dim.");
  	set_header(5,"@0g------@7g--@10g-------------------------@36g----------@47g----------@58g----------");
	}  	
}

bool TIscritti_application::user_create()
{
  _rel = new TRelation(LF_SOGGETTI);
  //_rel->add("TCS", "CODTAB==STATO",1,0,ALIAS_TCS);
  _rel->add("LCP", "CODTAB==LOCALITA",1,0,ALIAS_LCP);
  _rel->add(LF_COMUNI, "COM==COM");
	// per stampare nell'intestazione la denominazione della sezione  
  _rel->add(LF_SEZIONI, "CODSEZ==CODSEZ|CODSOT==CODSOT");

  _cur1 = add_cursor(new TCursor(_rel, "", 1));	//cursore ordinamento per codice
  _cur2 = add_cursor(new TCursor(_rel, "", 2));	//cursore ordinamento per cognome e nome
  _cur3 = add_cursor(new TCursor(_rel, "", 3));	//cursore ordinamento per sezione+sottogruppo+codice
  _cur4 = add_cursor(new TCursor(_rel, "", 4));	//cursore ordinamento per sezione+sottogruppo+cognome e nome

  _msk = new TMask("at2600a");
  
  _form_eti = new TEti_iscritti_form("AT_ETSOG");
  
  return TRUE;
}

bool TIscritti_application::user_destroy()
{
  delete _msk;
  delete _rel;
  delete _form_eti;
  return TRUE;
}

int at2600(int argc, char* argv[])
{

  TIscritti_application a;

  a.run(argc, argv, "Elenco iscritti/dimessi");

  return 0;
}
